SemwidgJS.ChartsLineChart = function() {

	this._addProperties([
		['x-Scale', 'static', 'category, time, linear, logarithmic'],
		['y-Scale', 'static', 'category, linear, logarithmic'],
		['y-Min', 'static', 'Minimum value on Y-Axis'],
		['y-Max', 'static', 'Maximum value on Y-Axis'],
	]);
};

SemwidgJS.ChartsLineChart.prototype = new SemwidgJS.ChartsMultipleDatasets();

SemwidgJS.ChartsLineChart.prototype._buildHtml = function() {

	var html = '';
	
	if (!this._isLoading()) {

		var data = this._getData({fill: false});

		var xScale = this.getXscale();
		if (SemwidgJS.Util.String.isEmpty(xScale)) {
			xScale = null;
		}

		var yScale = this.getYscale();
		if (SemwidgJS.Util.String.isEmpty(yScale)) {
			yScale = null;
		}

		var yMin = this.getYmin();
		if (SemwidgJS.Util.String.isEmpty(yMin)) {
			yMin = null;
		}

		var yMax = this.getYmax();
		if (SemwidgJS.Util.String.isEmpty(yMax)) {
			yMax = null;
		}

		var options = {
			scales: {
				xAxes: [{
					ticks: {
						autoSkip: true,
						autoSkipPadding: -30,
						padding: 20,
					}
				}],
				yAxes: [{
					ticks: {

					}
				}]
			},
			maintainAspectRatio: false
		};

		if (xScale) {
			options.scales.xAxes[0].type = xScale;
		}

		if (yScale) {
			options.scales.yAxes[0].type = yScale;
		}

		if (yMin) {
			options.scales.yAxes[0].ticks.suggestedMin = parseFloat(yMin);
		}

		if (yMax) {
			options.scales.yAxes[0].ticks.suggestedMax = parseFloat(yMax);
		}

		this._buildChart('line', data, options);
	}

};

SemwidgJS.WidgetProvider.registerWidgetType('SemwidgJS.ChartsLineChart');
