SemwidgJS.Endpoint = function() {

};

SemwidgJS.Endpoint.prototype = new SemwidgJS.ConfigElement();

SemwidgJS.Endpoint.prototype._getType = function() {
	return 'SwEndpoint';
};

SemwidgJS.Endpoint.prototype.getUrl = function() {
	return this.url;
};

SemwidgJS.Endpoint.prototype.setUrl = function(url) {
	
	if (SemwidgJS.Util.String.isEmpty(url)) {
		console.warn('Endpoint "' + this.getId() + '": url is empty');
	}

	this.url = url;

	this._dispatchEvent(new SemwidgJS.Event('urlChanged', this.url));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'url'));
};

SemwidgJS.Endpoint.prototype.getDefaultGraphUri = function() {
	return this.defaultGraphUri;
};

SemwidgJS.Endpoint.prototype.setDefaultGraphUri = function(defaultGraphUri) {
	this.defaultGraphUri = defaultGraphUri;

	this._dispatchEvent(new SemwidgJS.Event('defaultGraphUriChanged', this.defaultGraphUri));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'defaultGraphUri'));
};

SemwidgJS.Endpoint.prototype.getDefaultLang = function() {
	return this.defaultLang;
};

SemwidgJS.Endpoint.prototype.setDefaultLang = function(defaultLang) {
	this.defaultLang = defaultLang;

	this._dispatchEvent(new SemwidgJS.Event('defaultLangChanged', this.defaultLang));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'defaultLang'));
};

SemwidgJS.Endpoint.prototype.getProxy = function() {

	if (SemwidgJS.Util.String.isEmpty(this.proxy)) {
		return 'none';
	}

	return this.proxy;
};

SemwidgJS.Endpoint.prototype.setProxy = function(proxy) {

	if (SemwidgJS.getConfig().getProxy(proxy) == null
			&& !SemwidgJS.Util.String.isEmpty(proxy)
			&& proxy != "default" 
			&& proxy != "none") {
		console.warn('Endpoint "' + this.getId() + '": proxy "' + proxy + '" is not available');
	}
	
	this.proxy = proxy;

	this._dispatchEvent(new SemwidgJS.Event('proxyChanged', this.proxy));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'proxy'));

};

SemwidgJS.Endpoint.prototype.getDefault = function() {

	if (!this.isDefaultEndpoint) {
		this.isDefaultEndpoint = false;
	}

	return this.isDefaultEndpoint;
};

SemwidgJS.Endpoint.prototype.setDefault = function(isDefaultEndpoint) {

	isDefaultEndpoint = ('' + isDefaultEndpoint).toLowerCase();

	if (isDefaultEndpoint == 'true' || isDefaultEndpoint == '1') {
		isDefaultEndpoint = true;
	}else {
		isDefaultEndpoint = false;
	}
	
	this.isDefaultEndpoint = isDefaultEndpoint;

	this._dispatchEvent(new SemwidgJS.Event('isDefaultEndpointChanged', this.isDefaultEndpoint));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'isDefaultEndpoint'));

};

SemwidgJS.Endpoint.prototype.getHttpMethod = function() {

	if (!this.httpMethod) {
		this.httpMethod = 'POST';
	}

	return this.httpMethod;
};

SemwidgJS.Endpoint.prototype.setHttpMethod = function(httpMethod) {

	if (SemwidgJS.Util.String.isEmpty(httpMethod)) {
		httpMethod = 'POST';
	}

	httpMethod = httpMethod.toUpperCase();

	if (httpMethod == 'GET') {
		this.httpMethod = httpMethod;
	}else {
		this.httpMethod = 'POST';
	}
	
	this._dispatchEvent(new SemwidgJS.Event('httpMethodChanged', this.httpMethod));
	this._dispatchEvent(new SemwidgJS.Event('endpointChanged', 'httpMethod'));

};