SemwidgJS.ParameterObject = function() {

};

SemwidgJS.ParameterObject.prototype = new SemwidgJS.EventDispatcher();

SemwidgJS.ParameterObject.prototype.getWidget = function() {
	return this.widget;
};

SemwidgJS.ParameterObject.prototype.setWidget = function(widget) {
	this.widget = widget;
};

SemwidgJS.ParameterObject.prototype.getParameterName = function() {
	return this.parameterName;
};

SemwidgJS.ParameterObject.prototype.setParameterName = function(parameterName) {
	this.parameterName = parameterName;
};

SemwidgJS.ParameterObject.prototype.getOriginalString = function() {
	return this.originalString;
};

SemwidgJS.ParameterObject.prototype.setOriginalString = function(originalString) {
	this.originalString = originalString;
	this._dispatchEvent(new SemwidgJS.Event('originalStringChanged', originalString));
};

SemwidgJS.ParameterObject.prototype.getOriginalStringArray = function() {
	return this.originalStringArray;
};

SemwidgJS.ParameterObject.prototype.setOriginalStringArray = function(originalStringArray) {
	this.originalStringArray = originalStringArray;
	this._dispatchEvent(new SemwidgJS.Event('originalStringArrayChanged', originalStringArray));
};

SemwidgJS.ParameterObject.prototype.getParameterObjectParts = function() {
	return this.parameterObjectParts;
};

SemwidgJS.ParameterObject.prototype.setParameterObjectParts = function(parameterObjectParts) {
	this.parameterObjectParts = parameterObjectParts;
	this._dispatchEvent(new SemwidgJS.Event('parameterObjectPartsChanged', parameterObjectParts));
};

SemwidgJS.ParameterObject.prototype.addParameterObjectPart = function(parameterObjectPart) {
	this.getParameterObjectParts().push(parameterObjectPart);
	this._dispatchEvent(new SemwidgJS.Event('parameterObjectPartsChanged', this.getParameterObjectParts()));
};

SemwidgJS.ParameterObject.prototype.getDefaultValue = function(selectorFunction) {

	var str = '';
	var value = '';

	for (var i = 0; i < this.getParameterObjectParts().length; i++) {

		var part = this.getParameterObjectParts()[i];

		if (!part.getSparqlResult() || !part.getSparqlResult()[0]) {
			str += part.getOriginalString();
		}else {

			if (part.getSparqlResult()[0] &&
					part.getSparqlResult()[0].getResultObject() &&
					part.getSparqlResult()[0].getResultObject().getResults() &&
					part.getSparqlResult()[0].getResultObject().getResults().length > 0) {

				if (selectorFunction) {
					var results = part.getSparqlResult()[0].getResultObject().getResults();
					value = '' + selectorFunction(results);
					
				}else {
					var firstResultObject = part.getSparqlResult()[0].getResultObject().getResults()[0];
					var lastResultBinding = firstResultObject[firstResultObject.length - 1];
					value = lastResultBinding.getValue();
				}

				str += value; 
			}
		}
	}
	
	if (str.length > 0) {
		return str;
	}else {
		return null;
	}

};

SemwidgJS.ParameterObject.prototype.process = function() {

	this.setOriginalStringArray(
			SemwidgJS.Util.Widget.parseParameterParts(
				this.getOriginalString()));

	this.setParameterObjectParts([]);

	for (var i = 0; i < this.getOriginalStringArray().length; i++) {

		var part = new SemwidgJS.ParameterObject.Part();

		this.addParameterObjectPart(part);
		
		var handleResultsChangedEvent = (function(self) {
			return function(event) {
				var eventObject = {};
				eventObject.parameterObject = self;
				eventObject.parameterObjectPart = event.getDispatcher();
				eventObject.parameterObjectPartData = event.getData();
				self._dispatchEvent(new SemwidgJS.Event('resultsChanged', eventObject));
			}
		})(this);

		part._addEventListener('resultsChanged', handleResultsChangedEvent, this);

		part.setParameterObject(this);
		part.setOriginalString(this.getOriginalStringArray()[i]);
		part.process();
	}
};

SemwidgJS.ParameterObject.prototype.isLoading = function() {

	var pops = this.getParameterObjectParts();

	for (var i = 0; i < pops.length; i++) {
		if (pops[i].isLoading) {
			return true;
		}
	}

	return false;

};