SemwidgJS.SparqlResult = function() {	
	
};

SemwidgJS.SparqlResult.prototype = new SemwidgJS.EventDispatcher();

SemwidgJS.SparqlResult.prototype.getXmlResult = function() {
	return this.xmlResult;
};

SemwidgJS.SparqlResult.prototype.setXmlResult = function(xmlResult) {

	xmlResult = xmlResult.replace(/^<\?xml\s+version\s*=\s*(["'])[^\1]+\1[^?]*\?>/, ""); // bug 336551

	xmlResult = SemwidgJS.Util.sanitizeHtml(xmlResult);

	var tmp = new DOMParser();
	this.xmlResult = tmp.parseFromString(xmlResult, 'application/xml');
	this.resultObject = null;
	this.resultObject = this.getResultObject();

	this._dispatchEvent(new SemwidgJS.Event('xmlResultChanged', xmlResult));
	this._dispatchEvent(new SemwidgJS.Event('resultObjectChanged', this.getResultObject()));
};

SemwidgJS.SparqlResult.prototype.getResultObject = function() {

	if (!this.resultObject) {

		var v, r, b, i = 0;

		// No jQuery!!! jQuery deletes attributes.
		this.resultObject = new SemwidgJS.SparqlResult.ResultObject();

		var variables = this.xmlResult.querySelector('head').getElementsByTagName('variable');
		var variableNames = [];
		for (v = 0; v < variables.length; v++) {
			variableNames[v] = variables[v].getAttribute('name');
		}
		
		this.resultObject.setVariableNames(variableNames);

		var xmlResult = this.xmlResult.querySelector('results').getElementsByTagName('result');
		var results = [];
		var bindings = [];
		var binding;
		var xmlBindings;
		var xmlBinding;
		var variableName;
		var isUri = false;

		for (r = 0; r < xmlResult.length; r++) {
			
			bindings = [];

			xmlBindings = xmlResult[r].getElementsByTagName('binding');

			for (b = 0; b < variableNames.length; b++) {
				variableName = variableNames[b];

				xmlBinding = null;
				for (i = 0; i < xmlBindings.length; i++) {
					if (xmlBindings[i].getAttribute('name') == variableName) {
						xmlBinding = xmlBindings[i];
					}
				}
				
				binding = new SemwidgJS.SparqlResult.ResultBinding();

				binding.setName(variableName);

				if (xmlBinding) {

					isUri = xmlBinding.getElementsByTagName('uri').length > 0;
					
					if (isUri === true) {
						
						binding.setType('uri');
						binding.setValue(SemwidgJS.Util.sanitizeHtml(xmlBinding.getElementsByTagName('uri')[0].textContent));
					}else {
					
						var isLiteral = xmlBinding.getElementsByTagName('literal').length > 0;
						
						if (isLiteral === true) {
							binding.setType('literal');
							binding.setLang(SemwidgJS.Util.sanitizeHtml(xmlBinding.getElementsByTagName('literal')[0].getAttribute('xml:lang')));
							binding.setValue(SemwidgJS.Util.sanitizeHtml(xmlBinding.getElementsByTagName('literal')[0].textContent));
						}
					}
				} else {
					binding.setType('literal');
					binding.setValue('');
				}
				
				bindings[b] = binding;
			}
			
			results[r] = bindings;
		}
		this.resultObject.setResults(results);
	}
	
	return this.resultObject;
};


SemwidgJS.SparqlResult.ResultObject = function() {	
	
};

SemwidgJS.SparqlResult.ResultObject.prototype = new SemwidgJS.EventDispatcher();

SemwidgJS.SparqlResult.ResultObject.prototype.getVariableNames = function() {
	return this.variableNames;
};
	
SemwidgJS.SparqlResult.ResultObject.prototype.setVariableNames = function(variableNames) {
	this.variableNames = variableNames;
	this._dispatchEvent(new SemwidgJS.Event('variableNamesChanged', variableNames));
	this._dispatchEvent(new SemwidgJS.Event('resultObjectChanged', 'variableNames'));
};
	
SemwidgJS.SparqlResult.ResultObject.prototype.getResults = function() {
	return this.results;
};
	
SemwidgJS.SparqlResult.ResultObject.prototype.setResults = function(results) {
	this.results = results;
	this._registerResultBindingEvents();
	this._dispatchEvent(new SemwidgJS.Event('resultsChanged', results));
	this._dispatchEvent(new SemwidgJS.Event('resultObjectChanged', 'results'));
};

SemwidgJS.SparqlResult.ResultObject.prototype._registerResultBindingEvents = function() {
	for (var i = 0; i < this.getResults().length; i++) {
		var resultBindings = this.getResults()[i];

		for (var j = 0; j < resultBindings.length; j++) {
			var resultBinding = resultBindings[j];

			var handleResultBindingChangedEvent = function(event) {

				var eventObject = {};
				eventObject.resultObject = this;
				eventObject.resultBinding = event.getDispatcher();
				eventObject.resultBindingData = event.getData();

				this._dispatchEvent(new SemwidgJS.Event('resultBindingChanged', eventObject));

			};

			resultBinding._addEventListener('resultBindingChanged', handleResultBindingChangedEvent, this);
		}
	}
};


SemwidgJS.SparqlResult.ResultBinding = function() {	
	
};

SemwidgJS.SparqlResult.ResultBinding.prototype = new SemwidgJS.EventDispatcher();

SemwidgJS.SparqlResult.ResultBinding.prototype.getName = function() {
	return this.name;
};
	
SemwidgJS.SparqlResult.ResultBinding.prototype.setName = function(name) {
	this.name = name;
	this._dispatchEvent(new SemwidgJS.Event('nameChanged', name));
	this._dispatchEvent(new SemwidgJS.Event('resultBindingChanged', 'name'));
};

SemwidgJS.SparqlResult.ResultBinding.prototype.getType = function() {
	return this.type;
};

SemwidgJS.SparqlResult.ResultBinding.prototype.setType = function(type) {
	this.type = type;
	this._dispatchEvent(new SemwidgJS.Event('typeChanged', type));
	this._dispatchEvent(new SemwidgJS.Event('resultBindingChanged', 'type'));
};

SemwidgJS.SparqlResult.ResultBinding.prototype.getLang = function() {
	return this.lang;
};

SemwidgJS.SparqlResult.ResultBinding.prototype.setLang = function(lang) {
	this.lang = lang;
	this._dispatchEvent(new SemwidgJS.Event('langChanged', lang));
	this._dispatchEvent(new SemwidgJS.Event('resultBindingChanged', 'lang'));
};

SemwidgJS.SparqlResult.ResultBinding.prototype.getValue = function() {
	return this.value;
};
	
SemwidgJS.SparqlResult.ResultBinding.prototype.setValue = function(value) {
	this.value = value;
	this._dispatchEvent(new SemwidgJS.Event('valueChanged', value));
	this._dispatchEvent(new SemwidgJS.Event('resultBindingChanged', 'value'));
};