SemwidgJS.SwDropDown = function() {

	this._addProperties([
		['target', 'selector', 'Element and property to change with input text. Example: mySemwidgId.value'],
		['label-index', 'static', 'default = last'],
		['value-index', 'static', 'default = last - 1']
	]);

};

SemwidgJS.SwDropDown.prototype = new SemwidgJS.SwWidget();

SemwidgJS.SwDropDown.prototype._buildHtml = function() {

	var html = '';

	if (!this._isLoading()) {

		var joinedValues = this.getValueJoinedValues();

		var mathParser = new SemwidgJS.Util.MathParser();

		html += '<select ';
		html += this._getDefaultHtmlAttributes();
		if (this.getTarget()) {
			html += ' onchange="SemwidgJS.SwDropDown.widgetFunction_changeMapping(' + "'" + this.getTarget() + "', this.options[this.selectedIndex].value" + ');" ';
		}
		html += '>';

		var valueIndex = this.getValueindex();
		var labelIndex = this.getLabelindex();

		for (var i = 0; i < joinedValues.length; i++) {

			var jv = joinedValues[i][0];
			
			if (SemwidgJS.Util.String.isEmpty(valueIndex)) {
				valueIndex = 'last - 1';
			}

			if (SemwidgJS.Util.String.isEmpty(labelIndex)) {
				labelIndex = 'last';
			}

			var max = jv.getVariableNames().length - 1;

			valueIndex = mathParser.parse(('' + valueIndex).toLowerCase().replace('first', 0).replace('last', max));
			labelIndex = mathParser.parse(('' + labelIndex).toLowerCase().replace('first', 0).replace('last', max));

			if (valueIndex > max) {
				console.warn('ValueIndex out of bounds. Max value is ' + max + '.');
				valueIndex = max;
			}

			if (labelIndex > max) {
				console.warn('LabelIndex out of bounds. Max value is ' + max + '.');
				labelIndex = max;
			}

			for (var j = 0; j < jv.getResults().length; j++) {
				
				var result = jv.getResults()[j];

				var value = '';
				try {
					value = ('' + result[valueIndex].getValue()).trim();
				} catch (e) {};

				var label = value;
				try {
					label = ('' + result[labelIndex].getValue()).trim();
				} catch (e) {};

				html += '<option value="' + value + '">';
					html += label;
				html += '</option>';
					
			}
		}


		html += '</select>';
	}

	this._setHtml(html);

	if (this.getTarget() && SemwidgJS.Util.getValueBySelector(this.getTarget())) {
		var t = SemwidgJS.Util.getValueBySelector(this.getTarget());

		var select = this._getNode().firstChild;
		if (select) {
			var found = false;
			for (var k = 0; k < select.length; k++) {
				if (select[k].value == t) {
					select.selectedIndex = k;
					found = true;
					break;
				}
			}

			if (!found && select.length > 0) {
				SemwidgJS.SwDropDown.widgetFunction_changeMapping(this.getTarget(), select[0].value);
			}
		}
	}

};

SemwidgJS.SwDropDown.widgetFunction_changeMapping = function(target, value) {
	SemwidgJS.Util.setValueBySelector(target, value);
};

SemwidgJS.WidgetProvider.registerWidgetType('SemwidgJS.SwDropDown');
