SemwidgJS.SwImageGrid = function() {

	this._addProperties([
		['max', 'query', 'Number of maximum elements to display'],
		['max-width', 'static', 'Maximum width of each image. Default = 200px'],
		['max-height', 'static', 'Maximum height of each image. Default = 200px']
	]);

};

SemwidgJS.SwImageGrid.prototype = new SemwidgJS.SwWidget();

SemwidgJS.SwImageGrid.prototype._buildHtml = function() {

	var html = '';

	var joinedValues = this.getValueJoinedValues();

	if (joinedValues && joinedValues.length > 0) {
		var results = joinedValues[0][0].results;

		var w = this.getMaxwidthDefaultValue();
		var h = this.getMaxheightDefaultValue();
		var max = this.getMaxDefaultValue();

		if (SemwidgJS.Util.String.isEmpty(w)) {
			w = '200px';
		}

		if (SemwidgJS.Util.String.isEmpty(h)) {
			h = '200px';
		}

		if (SemwidgJS.Util.String.isEmpty(max)) {
			max = results.length;
		}else {
			max = Math.min(parseInt(max), results.length);
		}

		html += '<div ' + this._getDefaultHtmlAttributes() + '>';

		var result;
		var src;
		for (var i = 0; i < max; i++) {
			result = results[i];

			src = result[result.length - 1].value;

			html += '<div class="sw-imagegrid-inner" ';
			html += 'style="width: ' + w + '; height: ' + h + '; border: 1px solid #CCC; padding: 4px; margin: 4px; display: inline-block; vertical-align: middle; text-align: center;">';

			html += '<div style="display: inline-block; vertical-align: middle; height: 100%;"></div>';

			html += '<img ';
			if (!SemwidgJS.Util.String.isEmpty(src)) {
				html += 'src="' + src + '" ';
			}
			html += ' style="max-width: 100%; max-height: 100%; display: inline-block; vertical-align: middle;">'

			html += '</div>';
		}

		html += '<div style="clear: both;"></div>'

		html += '</div>';
	}

	this._setHtml(html);
};

SemwidgJS.WidgetProvider.registerWidgetType('SemwidgJS.SwImageGrid');
