SemwidgJS.UiUtil = function() {

};

SemwidgJS.UiUtil.UiUtilProvider = function() {

};

SemwidgJS.UiUtil.UiUtilProvider.prototype = new SemwidgJS.EventDispatcher();

SemwidgJS.UiUtil.UiUtilProvider.prototype.readUiUtils = function() {

	var tooltips = SemwidgJS.UiUtil.Tooltip.read();
	for (var i = 0; i < tooltips.length; i++) {
		tooltips[i]._build();
	}

	this.uiUtils = this.getUiUtils().concat(tooltips);

};

SemwidgJS.UiUtil.UiUtilProvider.prototype.getUiUtils = function() {

	if (!this.uiUtils) {
		this.uiUtils = new Array();
	}

	return this.uiUtils;

};

SemwidgJS.UiUtil.Tooltip = function() {

};

SemwidgJS.UiUtil.Tooltip.read = function() {

	var tooltips = new Array();

	var tooltipNodeList = $.find('[data-sw-uiutil="Tooltip"]');

	for (var i = 0; i < tooltipNodeList.length; i++) {
		
		var tooltip = new SemwidgJS.UiUtil.Tooltip();

		var tooltipNode = tooltipNodeList[i];

		tooltip.setTarget($(tooltipNode).data('swp-target'));

		tooltip._setNode(tooltipNode);

		tooltips.push(tooltip);
	}

	return tooltips;
};

SemwidgJS.UiUtil.Tooltip.prototype = new SemwidgJS.HtmlElement();

SemwidgJS.UiUtil.Tooltip.prototype.getTarget = function() {
	return this.target;
};

SemwidgJS.UiUtil.Tooltip.prototype.setTarget = function(target) {
	this.target = target;
};

SemwidgJS.UiUtil.Tooltip.prototype._build = function() {
	// hide target
	if (!SemwidgJS.Util.String.isEmpty(this.getTarget())) {
		var targetNode = $.find('[data-swp-id="' + this.getTarget() + '"]');
		$(targetNode).hide();
	}
	
	// link with target
	if (this._getNode()) {

		// underline source node
		$(this._getNode()).css('text-decoration', 'underline');

		var owner = this;
		var originalCss;

		var delayTimer = 0;

		var delayFunction = function(callback, ms){
			clearTimeout(delayTimer);
			delayTimer = setTimeout(callback, ms);
		};


		$(this._getNode()).mouseover(function() {
			var targetNode = $.find('[data-swp-id="' + owner.getTarget() + '"]');
			
			if (targetNode) {

				clearTimeout(delayTimer);

				var targetNodeObj = $(targetNode);
				var ownerNodeObj = $(owner._getNode());

				originalCss = targetNodeObj.attr('style');

				targetNodeObj.css('position', 'absolute');
				targetNodeObj.css('width', '25rem');
				targetNodeObj.css('max-height', '20rem');
				targetNodeObj.css('overflow-y', 'auto');
				targetNodeObj.css('z-index', '101');
				targetNodeObj.css('padding', '1rem');
				targetNodeObj.css('border', '2px solid #333');
				targetNodeObj.css('background-color', '#fefefe');

				var tooltipWidth = parseFloat(targetNodeObj.css('width'), 10);
				var sourceWidth = parseFloat(ownerNodeObj.css('width'), 10);
				var posX = ownerNodeObj.position().left - (tooltipWidth / 2) + (sourceWidth / 2);
				var posY = ownerNodeObj.position().top + parseFloat(ownerNodeObj.css('height'), 10);;
				targetNodeObj.css('left', posX);
				targetNodeObj.css('top', posY);

				targetNodeObj.show();
			}
		});

		$(this._getNode()).mouseout(function() {
			var targetNode = $.find('[data-swp-id="' + owner.getTarget() + '"]');
			if (targetNode) {

				var hide = function() {
					var targetNodeObj = $(targetNode);
					targetNodeObj.attr('style', originalCss);
					targetNodeObj.hide();
				};

				delayFunction(hide, 300);
			}
		});
	}

	var targetNode = $.find('[data-swp-id="' + owner.getTarget() + '"]');

	if (targetNode) {

		$(targetNode).mouseover(function() {

			clearTimeout(delayTimer);

		});

		$(targetNode).mouseout(function() {

			var hide = function() {
				var targetNodeObj = $(targetNode);
				targetNodeObj.attr('style', originalCss);
				targetNodeObj.hide();
			};

			delayFunction(hide, 500);

		});

	}

};



